//Wiznet HTML server using official C library
//RJA deriving from w5x00_http_server.c
/**
 * Copyright (c) 2021 WIZnet Co.,Ltd
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include "Platform.h"
#include "string.h" 

#include "wizchip_conf.h"
#include "w5x00_spi.h"
#include "w5500.h"
#include "socket.h"
#include "httpParser.h"
#include "httpUtil.h"
#include "httpServer.h"

#include "w5500.c"
#include "w5x00_spi.c"
#include "wizchip_conf.c"
#include "socket.c"
#include "httpParser.c"
#include "httpUtil.c"
#include "httpServer.c"



/* Buffer */
#define ETHERNET_BUF_MAX_SIZE (1024 * 2)

/* Socket */
#define HTTP_SOCKET_MAX_NUM 4

/**
 * ----------------------------------------------------------------------------------------------------
 * Variables
 * ----------------------------------------------------------------------------------------------------
 */
 /* Network */
static wiz_NetInfo g_net_info =
{
    .mac = {0x00, 0x08, 0xDC, 0x12, 0x34, 0x56}, // MAC address
    .ip = {192, 168, 1, 2},                     // IP address
    .sn = {255, 255, 255, 0},                    // Subnet Mask
    .gw = {192, 168, 11, 1},                     // Gateway
    .dns = {8, 8, 8, 8},                         // DNS server
    .dhcp = NETINFO_STATIC                       // DHCP enable/disable
};

/* HTTP */
static uint8_t g_http_send_buf[ETHERNET_BUF_MAX_SIZE] = {
    0,
};
static uint8_t g_http_recv_buf[ETHERNET_BUF_MAX_SIZE] = {
    0,
};
static uint8_t g_http_socket_num_list[HTTP_SOCKET_MAX_NUM] = { 0, 1, 2, 3 };




void Setup()
{
    char* buf = "Test this strtok";
    char* nexttok;
    nexttok = my_strtok((char*)buf, " ");
    printf("Setup...\n");

}

void Loop()
{
    printf("Loop...\n", f);
}




int main()
{
    /* Initialize */
    uint8_t i = 0;

    wizchip_spi_initialize();
    wizchip_cris_initialize();

    wizchip_reset();
    wizchip_initialize();
    wizchip_check();
    printf("Check complete.");

    network_initialize(g_net_info);
    
    httpServer_init(g_http_send_buf, g_http_recv_buf, HTTP_SOCKET_MAX_NUM, g_http_socket_num_list);

    /* Get network information */
   print_network_information(g_net_info);

    /* Register web page */
   reg_httpServer_webContent("index.html", index_page);

    /* Infinite loop */
    while (1)
    {
        /* Run HTTP server */
        for (i = 0; i < HTTP_SOCKET_MAX_NUM; i++)
        {
            httpServer_run(i);
        }
    }

 
    printf("Starting\n");

    Setup();

    for (;;)
    {
        Loop();
        _waitms(1000);
    }



}
